/**
 * Sample configuration file for running Design Room ONE with default settings using PM2
 */

module.exports = {
  /**
   * Application configuration section
   * http://pm2.keymetrics.io/docs/usage/application-declaration/
   */
  apps : [
    
    {
      name: 'DesignRoomONE',
      script: '../OnPrem_Design_Room/app.js',
      node_args: '--max_old_space_size=4096',
      error_file: "dr-err.log",
      out_file: "dr-out.log",
      log_date_format: "YYYY-MM-DD HH:mm Z",
      merge_logs: true,
      env: { /* Default environment is for production mode */
          DR_LOG_NO_TIMESTAMPS: true,
          NODE_ENV: 'production'
      },
      env_development: { /* This environment is for development mode */
          DR_LOG_NO_TIMESTAMPS: true,
          NODE_ENV: 'development'
      }
    }    
  ],

  /**
   * Deployment section
   * http://pm2.keymetrics.io/docs/usage/deployment/
   */
  // not used
};
